#ifndef ENUMTABLE_H
#define ENUMTABLE_H

#include <ivrs/wrapperstl.h>
#include <ivrs/wrapperclassinfo.h>

IVRS_NAMESPACE_BEGIN

class EnumTable {
public:

	EnumTable(WrapperClassInfo* scopename);

	void registerEnum(const char* enumname, const char* enumtype, int value);

	// return string with all registered enums for type 
	const char* allEnums(const char* type = 0);

	// return the name of an enums value
	const char* enumName(int value, const char* enumtype = 0);	
	// returns the value of an enums name
	int enumValue(const char* enumname, const char* enumtype = 0);
	

	// 'scope_enumname' has the form  "Scopename::Enumname"
	static int scopeEnumValue(const char* scope_enumname);

private:
	const char* scopename_;
	Enumtype2Map vec_; 
};

IVRS_NAMESPACE_END

#endif // ENUMTABLE_H
