#ifndef WRP_MATRIXWRP_H
#define WRP_MATRIXWRP_H
#include <ivrs/wrapper.h>
#include "../../../vrs/include/vrs/matrix.h"

IVRS_NAMESPACE_BEGIN
using namespace VRS;
using namespace LDX;

class Wrp_Matrix : public Wrapper {
public:
	Wrp_Matrix(void* obj = 0) : Wrapper(obj) { }
	virtual void destroyObject() {  delete reinterpret_cast<Matrix*>(obj_); obj_ = 0;  }
	virtual Wrapper* clone(void* obj) const { return new Wrp_Matrix(obj); }
	static WrapperClassInfo* WrapperInfo();
	virtual WrapperClassInfo* wrapperInfo() const { return Wrp_Matrix::WrapperInfo(); };

	virtual EnumTable* enumtable() const { return Wrp_Matrix::Enumtable(); }
	static EnumTable* Enumtable();

	//  Matrix (  )
	const char* m_5697_0(int argc, const char** argv);

	//  Matrix ( Matrix Matrix )
	const char* m_5697_20877(int argc, const char** argv);

	//  Matrix ( double double double double double double double double double double double double double double double double Matrix::MatrixType )
	const char* m_5697_1658494(int argc, const char** argv);

	// bool operator== ( Matrix )
	const char* m_27814_5697(int argc, const char** argv);

	// bool operator!= ( Matrix )
	const char* m_27282_5697(int argc, const char** argv);

	// double element ( unsigned%int unsigned%int )
	const char* m_19588_69281(int argc, const char** argv);

	// void setElement ( unsigned%int unsigned%int double )
	const char* m_13828_109926(int argc, const char** argv);

	// Matrix operator* ( Matrix )
	const char* m_24715_5697(int argc, const char** argv);

	// Vector operator* ( Vector )
	const char* m_24715_5649(int argc, const char** argv);

	// void transpose (  )
	const char* m_11865_0(int argc, const char** argv);

	// bool inverse ( Matrix )
	const char* m_19808_5697(int argc, const char** argv);

	// Matrix inverse (  )
	const char* m_19808_0(int argc, const char** argv);

	// void setHint ( Matrix::MatrixType )
	const char* m_7360_37838(int argc, const char** argv);

	// Matrix::MatrixType getHint (  )
	const char* m_19460_0(int argc, const char** argv);

	// Matrix scaling ( Vector )
	const char* m_7364_5649(int argc, const char** argv);

	// Matrix translation ( Vector )
	const char* m_16762_5649(int argc, const char** argv);

	// Matrix rotation ( Vector Vector double )
	const char* m_9744_45188(int argc, const char** argv);

	virtual MethodTable* methodTable() const;
};
const char* type2str(const Matrix::MatrixType& e);
Matrix::MatrixType str2type(const char* in, Matrix::MatrixType*);

IVRS_NAMESPACE_END



#endif //WRP_MATRIXWRP_H
