#ifndef TCLCALLMANAGER_H
#define TCLCALLMANAGER_H

#include <vrs/tcl/tcltool.h>
#include <ivrs/wrapper.h>

IVRS_NAMESPACE_BEGIN

class TclCallManager {
public:

	// Tcl callback funktions
	static int objectNew(ClientData clientData, Tcl_Interp* interp,int argc, const char* argv[]);	
	static int objectDelete(ClientData clientData, Tcl_Interp* interp,int argc, const char* argv[]);	
	
	static int objectMethodCall(ClientData clientData, Tcl_Interp* interp,int argc, const char* argv[]);
	static int classMethodCall(ClientData clientData, Tcl_Interp* interp,int argc, const char* argv[]);	
	
	// clean all created objects 
	static int vrsManage(ClientData clientData, Tcl_Interp* interp,int argc, const char* argv[]);

	// create Tcl commands for stub creation
	static void initializeComands(Tcl_Interp* interp);	

	// create explicit  
	static char* createTclObject(Wrapper* stub = 0, char* forceName = 0);	

	
private:
	TclCallManager();	
};

IVRS_NAMESPACE_END

#undef TCL_STORAGE_CLASS
#define TCL_STORAGE_CLASS DLLEXPORT

EXTERN int Vrs_Init (Tcl_Interp *interp);

#undef TCL_STORAGE_CLASS
#define TCL_STORAGE_CLASS DLLIMPORT


#endif //TclCallManager_H