#ifndef WRAPPERCLASSINFO_H
#define WRAPPERCLASSINFO_H

#include <ivrs/wrapperexception.h>
#include <typeinfo>

IVRS_NAMESPACE_BEGIN

using std::type_info;

class WrapperClassInfo {
public:	
	
    WrapperClassInfo(const type_info& master, WrapperClassInfo* masterbaseinfo);
    
    const type_info* masterClassTypeInfo() const { return master_; }	
    const char* masterClassName() const { return name_; }

    WrapperClassInfo* masterBaseInfo() const { return masterbaseinfo_; }

private: 
    const type_info* master_;
    WrapperClassInfo* masterbaseinfo_;	
	const char* name_;
};



// needed for null type
class NullType {};
static const type_info& NULLTYPE = typeid(NullType);


IVRS_NAMESPACE_END

#endif // WRAPPERCLASSINFO_H
