#ifndef WrapperManager_H
#define WrapperManager_H

#include <ivrs/wrapperstl.h>
#include <ivrs/wrapper.h>

IVRS_NAMESPACE_BEGIN

class WrapperManager {
public:

	// prototypes
	static void registerPrototype(Wrapper* obj);
	static Wrapper* wrapperPrototype(const char* classname);
    static Wrapper* wrapperPrototype(const type_info* type);
	
	// wrapper objects
	static void add(Wrapper* obj);	
    static void remove(Wrapper* obj);
    static void clear();

	static Wrapper* find(const char* wrappername, const type_info* desiredtype);
	static Wrapper* find(const void* obj,   const type_info* desiredtype);				
    
    // check type of wrapper
    static bool check(Wrapper* wrp,   const type_info* desiredtype);
	

	// get content
	static WrpTableItr allPrototypes();
	static WrpTableItr allObjects();	
};


// help class for prototype registration
class PrototypeRegister {
public: 
	PrototypeRegister(Wrapper* wrp) {
		WrapperManager::registerPrototype(wrp);
	}
};


IVRS_NAMESPACE_END

#endif //WrapperManager_H
