#ifndef MISC_H
#define MISC_H

#include <ivrs/wrapperexception.h>
#include <map>
#include <vector>
#include <typeinfo>

IVRS_NAMESPACE_BEGIN
using std::type_info;

struct charPointerLess {	
	bool operator() (const char* a, const char* b) const {	return (strcmp(a,b) < 0); }
};

typedef std::map<const char*,int,charPointerLess> Enumname2Int;
typedef Enumname2Int::iterator EII;

typedef std::map<const char*,Enumname2Int*,charPointerLess> Enumtype2Map;
typedef Enumtype2Map::iterator ETI;


class MethodInfo;
typedef std::vector<MethodInfo*> MethodVector;
typedef MethodVector::iterator MVI;


class Wrapper;

// maps string to wrapper 
typedef std::map<const char*,Wrapper*,charPointerLess> Str2WrpMap;
typedef Str2WrpMap::iterator SWI;
typedef std::pair<SWI,SWI> WrpTableItr;

// maps wrapper's void* to corresponding wrapper
typedef std::map<const void*,Wrapper*> Void2WrpMap;


struct typeinfoLess {	
	bool operator() (const type_info* a, const type_info* b) const {	return (a->before(*b) != 0); }
};
typedef std::map<const type_info*,Wrapper*,typeinfoLess> Type2WrpMap;

IVRS_NAMESPACE_END

#endif // MISC_H
