#include <ivrs/stringconvert.h>
#include <ivrs/matrixwrp.h>
#include <ivrs/vectorwrp.h>
#include <ivrs/methodtable.h>
#include <ivrs/wrappermanager.h>
#include <ivrs/enumtable.h>

IVRS_NAMESPACE_BEGIN
using namespace VRS;
using namespace LDX;

WrapperClassInfo* Wrp_Matrix::WrapperInfo() {
	static WrapperClassInfo i( typeid(Matrix) , Wrapper::WrapperInfo());
	return &i;
}

//  Matrix (  )
const char* Wrp_Matrix::m_5697_0(int argc, const char** argv) {
	obj_ = new Matrix();
	return 0;
}

//  Matrix ( Matrix Matrix )
const char* Wrp_Matrix::m_5697_20877(int argc, const char** argv) {
	Matrix arg0 = str2type(argv[0],(Matrix*)0);
	Matrix arg1 = str2type(argv[1],(Matrix*)0);
	obj_ = new Matrix(arg0,arg1);
	return 0;
}

//  Matrix ( double double double double double double double double double double double double double double double double Matrix::MatrixType )
const char* Wrp_Matrix::m_5697_1658494(int argc, const char** argv) {
	double arg0 = str2type(argv[0],(double*)0);
	double arg1 = str2type(argv[1],(double*)0);
	double arg2 = str2type(argv[2],(double*)0);
	double arg3 = str2type(argv[3],(double*)0);
	double arg4 = str2type(argv[4],(double*)0);
	double arg5 = str2type(argv[5],(double*)0);
	double arg6 = str2type(argv[6],(double*)0);
	double arg7 = str2type(argv[7],(double*)0);
	double arg8 = str2type(argv[8],(double*)0);
	double arg9 = str2type(argv[9],(double*)0);
	double arg10 = str2type(argv[10],(double*)0);
	double arg11 = str2type(argv[11],(double*)0);
	double arg12 = str2type(argv[12],(double*)0);
	double arg13 = str2type(argv[13],(double*)0);
	double arg14 = str2type(argv[14],(double*)0);
	double arg15 = str2type(argv[15],(double*)0);
	Matrix::MatrixType arg16 = (argc <= 16) ? Matrix::MT_Unknown : str2type(argv[16],(Matrix::MatrixType*)0);
	obj_ = new Matrix(arg0,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11,arg12,arg13,arg14,arg15,arg16);
	return 0;
}

// bool operator== ( Matrix )
const char* Wrp_Matrix::m_27814_5697(int argc, const char** argv) {
	Matrix arg0 = str2type(argv[0],(Matrix*)0);
	const bool value = reinterpret_cast<Matrix*>(obj_)->operator==(arg0);
	return type2str(value);
}

// bool operator!= ( Matrix )
const char* Wrp_Matrix::m_27282_5697(int argc, const char** argv) {
	Matrix arg0 = str2type(argv[0],(Matrix*)0);
	const bool value = reinterpret_cast<Matrix*>(obj_)->operator!=(arg0);
	return type2str(value);
}

// double element ( unsigned%int unsigned%int )
const char* Wrp_Matrix::m_19588_69281(int argc, const char** argv) {
	unsigned int arg0 = str2type(argv[0],(unsigned int*)0);
	unsigned int arg1 = str2type(argv[1],(unsigned int*)0);
	const double value = reinterpret_cast<Matrix*>(obj_)->element(arg0,arg1);
	return type2str(value);
}

// void setElement ( unsigned%int unsigned%int double )
const char* Wrp_Matrix::m_13828_109926(int argc, const char** argv) {
	unsigned int arg0 = str2type(argv[0],(unsigned int*)0);
	unsigned int arg1 = str2type(argv[1],(unsigned int*)0);
	double arg2 = str2type(argv[2],(double*)0);
	reinterpret_cast<Matrix*>(obj_)->setElement(arg0,arg1,arg2);
	return 0;
}

// Matrix operator* ( Matrix )
const char* Wrp_Matrix::m_24715_5697(int argc, const char** argv) {
	Matrix arg0 = str2type(argv[0],(Matrix*)0);
	const Matrix value = reinterpret_cast<Matrix*>(obj_)->operator*(arg0);
	return type2str(value);
}

// Vector operator* ( Vector )
const char* Wrp_Matrix::m_24715_5649(int argc, const char** argv) {
	Vector arg0 = str2type(argv[0],(Vector*)0);
	const Vector value = reinterpret_cast<Matrix*>(obj_)->operator*(arg0);
	return type2str(value);
}

// void transpose (  )
const char* Wrp_Matrix::m_11865_0(int argc, const char** argv) {
	reinterpret_cast<Matrix*>(obj_)->transpose();
	return 0;
}

// bool inverse ( Matrix )
const char* Wrp_Matrix::m_19808_5697(int argc, const char** argv) {
	Matrix arg0 = str2type(argv[0],(Matrix*)0);
	const bool value = reinterpret_cast<Matrix*>(obj_)->inverse(arg0);
	return type2str(value);
}

// Matrix inverse (  )
const char* Wrp_Matrix::m_19808_0(int argc, const char** argv) {
	const Matrix value = reinterpret_cast<Matrix*>(obj_)->inverse();
	return type2str(value);
}

// void setHint ( Matrix::MatrixType )
const char* Wrp_Matrix::m_7360_37838(int argc, const char** argv) {
	Matrix::MatrixType arg0 = (argc <= 0) ? Matrix::MT_Check : str2type(argv[0],(Matrix::MatrixType*)0);
	reinterpret_cast<Matrix*>(obj_)->setHint(arg0);
	return 0;
}

// Matrix::MatrixType getHint (  )
const char* Wrp_Matrix::m_19460_0(int argc, const char** argv) {
	const Matrix::MatrixType value = reinterpret_cast<Matrix*>(obj_)->getHint();
	return type2str(value);
}

// Matrix scaling ( Vector )
const char* Wrp_Matrix::m_7364_5649(int argc, const char** argv) {
	Vector arg0 = (argc <= 0) ? Vector(1.0,1.0,1.0) : str2type(argv[0],(Vector*)0);
	const Matrix value = Matrix::scaling(arg0);
	return type2str(value);
}

// Matrix translation ( Vector )
const char* Wrp_Matrix::m_16762_5649(int argc, const char** argv) {
	Vector arg0 = (argc <= 0) ? Vector(0.0,0.0,0.0) : str2type(argv[0],(Vector*)0);
	const Matrix value = Matrix::translation(arg0);
	return type2str(value);
}

// Matrix rotation ( Vector Vector double )
const char* Wrp_Matrix::m_9744_45188(int argc, const char** argv) {
	Vector arg0 = (argc <= 0) ? Vector(1.0,0.0,0.0) : str2type(argv[0],(Vector*)0);
	Vector arg1 = (argc <= 1) ? Vector(0.0,0.0,0.0) : str2type(argv[1],(Vector*)0);
	double arg2 = (argc <= 2) ? 0.0 : str2type(argv[2],(double*)0);
	const Matrix value = Matrix::rotation(arg0,arg1,arg2);
	return type2str(value);
}

MethodTable* Wrp_Matrix::methodTable() const {
	static MethodTable* dta_ = 0;
	if (!dta_) {
		dta_ = new MethodTable(Wrapper::methodTable());
		dta_->insert("Ctor",(Wrapper::FKT)&Wrp_Matrix::m_5697_0,"","","","",0,0,MethodTable::CTOR);
		dta_->insert("Ctor",(Wrapper::FKT)&Wrp_Matrix::m_5697_20877,"","Matrix Matrix","m1 m2","{} {}",2,2,MethodTable::CTOR);
		dta_->insert("Ctor",(Wrapper::FKT)&Wrp_Matrix::m_5697_1658494,"","double double double double double double double double double double double double double double double double Matrix::MatrixType","m00 m01 m02 m03 m10 m11 m12 m13 m20 m21 m22 m23 m30 m31 m32 m33 hint","{} {} {} {} {} {} {} {} {} {} {} {} {} {} {} {} Matrix::MT_Unknown",16,17,MethodTable::CTOR);
		dta_->insert("==",(Wrapper::FKT)&Wrp_Matrix::m_27814_5697,"bool","Matrix","m","{}",1,1,MethodTable::METHOD);
		dta_->insert("!=",(Wrapper::FKT)&Wrp_Matrix::m_27282_5697,"bool","Matrix","m","{}",1,1,MethodTable::METHOD);
		dta_->insert("element",(Wrapper::FKT)&Wrp_Matrix::m_19588_69281,"double","unsigned%int unsigned%int","i j","{} {}",2,2,MethodTable::METHOD);
		dta_->insert("setElement",(Wrapper::FKT)&Wrp_Matrix::m_13828_109926,"void","unsigned%int unsigned%int double","i j value","{} {} {}",3,3,MethodTable::METHOD);
		dta_->insert("*",(Wrapper::FKT)&Wrp_Matrix::m_24715_5697,"Matrix","Matrix","m","{}",1,1,MethodTable::METHOD);
		dta_->insert("*",(Wrapper::FKT)&Wrp_Matrix::m_24715_5649,"Vector","Vector","v","{}",1,1,MethodTable::METHOD);
		dta_->insert("transpose",(Wrapper::FKT)&Wrp_Matrix::m_11865_0,"void","","","",0,0,MethodTable::METHOD);
		dta_->insert("inverse",(Wrapper::FKT)&Wrp_Matrix::m_19808_5697,"bool","Matrix","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("inverse",(Wrapper::FKT)&Wrp_Matrix::m_19808_0,"Matrix","","","",0,0,MethodTable::METHOD);
		dta_->insert("setHint",(Wrapper::FKT)&Wrp_Matrix::m_7360_37838,"void","Matrix::MatrixType","matrixtype","Matrix::MT_Check",0,1,MethodTable::METHOD);
		dta_->insert("getHint",(Wrapper::FKT)&Wrp_Matrix::m_19460_0,"Matrix::MatrixType","","","",0,0,MethodTable::METHOD);
		dta_->insert("scaling",(Wrapper::FKT)&Wrp_Matrix::m_7364_5649,"Matrix","Vector","s","Vector(1.0,1.0,1.0)",0,1,MethodTable::STATIC);
		dta_->insert("translation",(Wrapper::FKT)&Wrp_Matrix::m_16762_5649,"Matrix","Vector","t","Vector(0.0,0.0,0.0)",0,1,MethodTable::STATIC);
		dta_->insert("rotation",(Wrapper::FKT)&Wrp_Matrix::m_9744_45188,"Matrix","Vector Vector double","axis center angle","Vector(1.0,0.0,0.0) Vector(0.0,0.0,0.0) 0.0",0,3,MethodTable::STATIC);

	}
	return dta_;
}
EnumTable* Wrp_Matrix::Enumtable() {
	static EnumTable* etb_ = 0;
	if(!etb_) {
		etb_  = new EnumTable(Wrp_Matrix::WrapperInfo());
		static const char* strMatrixType = "MatrixType";
        etb_->registerEnum("MT_Identity", strMatrixType, Matrix::MT_Identity);
		etb_->registerEnum("MT_Scale", strMatrixType, Matrix::MT_Scale);
		etb_->registerEnum("MT_Translate", strMatrixType, Matrix::MT_Translate);
		etb_->registerEnum("MT_Unknown", strMatrixType, Matrix::MT_Unknown);
		etb_->registerEnum("MT_Check", strMatrixType, Matrix::MT_Check);
	}
	return etb_;
}
const char* type2str(const Matrix::MatrixType& e) {
	return Wrp_Matrix::Enumtable()->enumName(e,"MatrixType");
}
Matrix::MatrixType str2type(const char* in, Matrix::MatrixType*) {
	return (Matrix::MatrixType)((Wrp_Matrix::Enumtable()->enumValue(in,"MatrixType")));
}
static PrototypeRegister instanceOfWrp_Matrix(new Wrp_Matrix(0));

IVRS_NAMESPACE_END

