#include <ivrs/enumtable.h>
#include <ivrs/wrapper.h>
#include <ivrs/wrappermanager.h>

IVRS_NAMESPACE_BEGIN

class GL {};
static char* masterstring = "GL";

class OpengGLWrapper : public Wrapper {
public:	
	


	virtual Wrapper* clone(void* masterobj) const { return 0; }
	virtual EnumTable* enumtable() const { return Enumtable(); }


	static EnumTable* Enumtable() {
		static EnumTable* etb_ = 0;
		if (!etb_) {
            etb_ = new EnumTable(0);
            
            etb_->registerEnum("GL_RGB_S3TC",masterstring,0x83A0);
            etb_->registerEnum("GL_RGB4_S3TC",masterstring,0x83A1);
			etb_->registerEnum("GL_RGBA_S3TC",masterstring,0x83A2);
			etb_->registerEnum("GL_RGBA4_S3TC",masterstring,0x83A3);			

			etb_->registerEnum("GL_ACCUM",masterstring,0x0100);
			etb_->registerEnum("GL_LOAD",masterstring,0x0101);
			etb_->registerEnum("GL_RETURN",masterstring,0x0102);
			etb_->registerEnum("GL_MULT",masterstring,0x0103);
			etb_->registerEnum("GL_ADD",masterstring,0x0104);

			etb_->registerEnum("GL_FRONT_LEFT",masterstring,0x0400);
			etb_->registerEnum("GL_FRONT_RIGHT",masterstring,0x0401);
			etb_->registerEnum("GL_BACK_LEFT",masterstring,0x0402);
			etb_->registerEnum("GL_BACK_RIGHT",masterstring,0x0403);
			etb_->registerEnum("GL_FRONT",masterstring,0x0404);
			etb_->registerEnum("GL_BACK",masterstring,0x0405);
			etb_->registerEnum("GL_LEFT",masterstring,0x0406);
			etb_->registerEnum("GL_RIGHT",masterstring,0x0407);
			etb_->registerEnum("GL_FRONT_AND_BACK",masterstring,0x0408);
			etb_->registerEnum("GL_AUX0",masterstring,0x0409);
			etb_->registerEnum("GL_AUX1",masterstring,0x040A);
			etb_->registerEnum("GL_AUX2",masterstring,0x040B);
			etb_->registerEnum("GL_AUX3",masterstring,0x040C);

			/* AlphaFunction */
			etb_->registerEnum("GL_NEVER",masterstring,0x0200);
			etb_->registerEnum("GL_LESS",masterstring,0x0201);
			etb_->registerEnum("GL_EQUAL",masterstring,0x0202);
			etb_->registerEnum("GL_LEQUAL",masterstring,0x0203);
			etb_->registerEnum("GL_GREATER",masterstring,0x0204);
			etb_->registerEnum("GL_NOTEQUAL",masterstring,0x0205);
			etb_->registerEnum("GL_GEQUAL",masterstring,0x0206);
			etb_->registerEnum("GL_ALWAYS",masterstring,0x0207);

			/* BlendingFactorDest */
			etb_->registerEnum("GL_ZERO",masterstring,0);
			etb_->registerEnum("GL_ONE",masterstring,1);
			etb_->registerEnum("GL_SRC_COLOR",masterstring,0x0300);
			etb_->registerEnum("GL_ONE_MINUS_SRC_COLOR",masterstring,0x0301);
			etb_->registerEnum("GL_SRC_ALPHA",masterstring,0x0302);
			etb_->registerEnum("GL_ONE_MINUS_SRC_ALPHA",masterstring,0x0303);
			etb_->registerEnum("GL_DST_ALPHA",masterstring,0x0304);
			etb_->registerEnum("GL_ONE_MINUS_DST_ALPHA",masterstring,0x0305);

			/* BlendingFactorSrc */
			/*      GL_ZERO */
			/*      GL_ONE */
			etb_->registerEnum("GL_DST_COLOR",masterstring,0x0306);
			etb_->registerEnum("GL_ONE_MINUS_DST_COLOR",masterstring,0x0307);
			etb_->registerEnum("GL_SRC_ALPHA_SATURATE",masterstring,0x0308);
			/*      GL_SRC_ALPHA */
			/*      GL_ONE_MINUS_SRC_ALPHA */
			/*      GL_DST_ALPHA */
			/*      GL_ONE_MINUS_DST_ALPHA */

			/* Boolean */
			etb_->registerEnum("GL_TRUE",masterstring,1);
			etb_->registerEnum("GL_FALSE",masterstring,0);

			/* DataType */
			etb_->registerEnum("GL_BYTE",masterstring,0x1400);
			etb_->registerEnum("GL_UNSIGNED_BYTE",masterstring,0x1401);
			etb_->registerEnum("GL_SHORT",masterstring,0x1402);
			etb_->registerEnum("GL_UNSIGNED_SHORT",masterstring,0x1403);
			etb_->registerEnum("GL_INT",masterstring,0x1404);
			etb_->registerEnum("GL_UNSIGNED_INT",masterstring,0x1405);
			etb_->registerEnum("GL_FLOAT",masterstring,0x1406);
			etb_->registerEnum("GL_2_BYTES",masterstring,0x1407);
			etb_->registerEnum("GL_3_BYTES",masterstring,0x1408);
			etb_->registerEnum("GL_4_BYTES",masterstring,0x1409);
			etb_->registerEnum("GL_DOUBLE",masterstring,0x140A);

			/* GetTarget */
			etb_->registerEnum("GL_DEPTH_RANGE",masterstring,0x0B70);
			etb_->registerEnum("GL_DEPTH_TEST",masterstring,0x0B71);
			etb_->registerEnum("GL_DEPTH_WRITEMASK",masterstring,0x0B72);
			etb_->registerEnum("GL_DEPTH_CLEAR_VALUE",masterstring,0x0B73);
			etb_->registerEnum("GL_DEPTH_FUNC",masterstring,0x0B74);
			etb_->registerEnum("GL_ACCUM_CLEAR_VALUE",masterstring,0x0B80);
			etb_->registerEnum("GL_STENCIL_TEST",masterstring,0x0B90);
			etb_->registerEnum("GL_STENCIL_CLEAR_VALUE",masterstring,0x0B91);
			etb_->registerEnum("GL_STENCIL_FUNC",masterstring,0x0B92);
			etb_->registerEnum("GL_STENCIL_VALUE_MASK",masterstring,0x0B93);
			etb_->registerEnum("GL_STENCIL_FAIL",masterstring,0x0B94);
			etb_->registerEnum("GL_STENCIL_PASS_DEPTH_FAIL",masterstring,0x0B95);
			etb_->registerEnum("GL_STENCIL_PASS_DEPTH_PASS",masterstring,0x0B96);
			etb_->registerEnum("GL_STENCIL_REF",masterstring,0x0B97);
			etb_->registerEnum("GL_STENCIL_WRITEMASK",masterstring,0x0B98);
			etb_->registerEnum("GL_ALPHA_TEST",masterstring,0x0BC0);
			etb_->registerEnum("GL_ALPHA_TEST_FUNC",masterstring,0x0BC1);
			etb_->registerEnum("GL_ALPHA_TEST_REF",masterstring,0x0BC2);
			etb_->registerEnum("GL_DITHER",masterstring,0x0BD0);
			etb_->registerEnum("GL_BLEND_DST",masterstring,0x0BE0);
			etb_->registerEnum("GL_BLEND_SRC",masterstring,0x0BE1);
			etb_->registerEnum("GL_BLEND",masterstring,0x0BE2);
			etb_->registerEnum("GL_SCISSOR_BOX",masterstring,0x0C10);
			etb_->registerEnum("GL_SCISSOR_TEST",masterstring,0x0C11);
			etb_->registerEnum("GL_INDEX_CLEAR_VALUE",masterstring,0x0C20);
			etb_->registerEnum("GL_INDEX_WRITEMASK",masterstring,0x0C21);
			etb_->registerEnum("GL_COLOR_CLEAR_VALUE",masterstring,0x0C22);
			etb_->registerEnum("GL_COLOR_WRITEMASK",masterstring,0x0C23);
			etb_->registerEnum("GL_INDEX_MODE",masterstring,0x0C30);
			etb_->registerEnum("GL_RGBA_MODE",masterstring,0x0C31);
			etb_->registerEnum("GL_DOUBLEBUFFER",masterstring,0x0C32);
			etb_->registerEnum("GL_STEREO",masterstring,0x0C33);
			etb_->registerEnum("GL_NAME_STACK_DEPTH",masterstring,0x0D70);
			etb_->registerEnum("GL_AUTO_NORMAL",masterstring,0x0D80);
			etb_->registerEnum("GL_TEXTURE_1D",masterstring,0x0DE0);
			etb_->registerEnum("GL_TEXTURE_2D",masterstring,0x0DE1);

			/* LogicOp */
			etb_->registerEnum("GL_CLEAR",masterstring,0x1500);
			etb_->registerEnum("GL_AND",masterstring,0x1501);
			etb_->registerEnum("GL_AND_REVERSE",masterstring,0x1502);
			etb_->registerEnum("GL_COPY",masterstring,0x1503);
			etb_->registerEnum("GL_AND_INVERTED",masterstring,0x1504);
			etb_->registerEnum("GL_NOOP",masterstring,0x1505);
			etb_->registerEnum("GL_XOR",masterstring,0x1506);
			etb_->registerEnum("GL_OR",masterstring,0x1507);
			etb_->registerEnum("GL_NOR",masterstring,0x1508);
			etb_->registerEnum("GL_EQUIV",masterstring,0x1509);
			etb_->registerEnum("GL_INVERT",masterstring,0x150A);
			etb_->registerEnum("GL_OR_REVERSE",masterstring,0x150B);
			etb_->registerEnum("GL_COPY_INVERTED",masterstring,0x150C);
			etb_->registerEnum("GL_OR_INVERTED",masterstring,0x150D);
			etb_->registerEnum("GL_NAND",masterstring,0x150E);
			etb_->registerEnum("GL_SET",masterstring,0x150F);

			/* PixelCopyType */
			etb_->registerEnum("GL_COLOR",masterstring,0x1800);
			etb_->registerEnum("GL_DEPTH",masterstring,0x1801);
			etb_->registerEnum("GL_STENCIL",masterstring,0x1802);

			/* PixelFormat */
			etb_->registerEnum("GL_COLOR_INDEX",masterstring,0x1900);
			etb_->registerEnum("GL_STENCIL_INDEX",masterstring,0x1901);
			etb_->registerEnum("GL_DEPTH_COMPONENT",masterstring,0x1902);
			etb_->registerEnum("GL_RED",masterstring,0x1903);
			etb_->registerEnum("GL_GREEN",masterstring,0x1904);
			etb_->registerEnum("GL_BLUE",masterstring,0x1905);
			etb_->registerEnum("GL_ALPHA",masterstring,0x1906);
			etb_->registerEnum("GL_RGB",masterstring,0x1907);
			etb_->registerEnum("GL_RGBA",masterstring,0x1908);
			etb_->registerEnum("GL_LUMINANCE",masterstring,0x1909);
			etb_->registerEnum("GL_LUMINANCE_ALPHA",masterstring,0x190A);


			/* StencilOp */
			/*      GL_ZERO */
			etb_->registerEnum("GL_KEEP",masterstring,0x1E00);
			etb_->registerEnum("GL_REPLACE",masterstring,0x1E01);
			etb_->registerEnum("GL_INCR",masterstring,0x1E02);
			etb_->registerEnum("GL_DECR",masterstring,0x1E03);
			/*      GL_INVERT */

			/* TextureEnvMode */
			etb_->registerEnum("GL_MODULATE",masterstring,0x2100);
			etb_->registerEnum("GL_DECAL",masterstring,0x2101);
			/*      GL_BLEND */
			/*      GL_REPLACE */

			/* TextureEnvParameter */
			etb_->registerEnum("GL_TEXTURE_ENV_MODE",masterstring,0x2200);
			etb_->registerEnum("GL_TEXTURE_ENV_COLOR",masterstring,0x2201);

			/* TextureEnvTarget */
			etb_->registerEnum("GL_TEXTURE_ENV",masterstring,0x2300);

			/* TextureGenMode */
			etb_->registerEnum("GL_EYE_LINEAR",masterstring,0x2400);
			etb_->registerEnum("GL_OBJECT_LINEAR",masterstring,0x2401);
			etb_->registerEnum("GL_SPHERE_MAP",masterstring,0x2402);

			/* TextureGenParameter */
			etb_->registerEnum("GL_TEXTURE_GEN_MODE",masterstring,0x2500);
			etb_->registerEnum("GL_OBJECT_PLANE",masterstring,0x2501);
			etb_->registerEnum("GL_EYE_PLANE",masterstring,0x2502);

			/* TextureMagFilter */
			etb_->registerEnum("GL_NEAREST",masterstring,0x2600);
			etb_->registerEnum("GL_LINEAR",masterstring,0x2601);

			/* TextureMinFilter */
			/*      GL_NEAREST */
			/*      GL_LINEAR */
			etb_->registerEnum("GL_NEAREST_MIPMAP_NEAREST",masterstring,0x2700);
			etb_->registerEnum("GL_LINEAR_MIPMAP_NEAREST",masterstring,0x2701);
			etb_->registerEnum("GL_NEAREST_MIPMAP_LINEAR",masterstring,0x2702);
			etb_->registerEnum("GL_LINEAR_MIPMAP_LINEAR",masterstring,0x2703);

			/* TextureParameterName */
			etb_->registerEnum("GL_TEXTURE_MAG_FILTER",masterstring,0x2800);
			etb_->registerEnum("GL_TEXTURE_MIN_FILTER",masterstring,0x2801);
			etb_->registerEnum("GL_TEXTURE_WRAP_S",masterstring,0x2802);
			etb_->registerEnum("GL_TEXTURE_WRAP_T",masterstring,0x2803);
			/*      GL_TEXTURE_BORDER_COLOR */
			/*      GL_TEXTURE_PRIORITY */

			/* TextureWrapMode */
			etb_->registerEnum("GL_CLAMP",masterstring,0x2900);
			etb_->registerEnum("GL_REPEAT",masterstring,0x2901);

			/* texture */
			etb_->registerEnum("GL_ALPHA4",masterstring,0x803B);
			etb_->registerEnum("GL_ALPHA8",masterstring,0x803C);
			etb_->registerEnum("GL_ALPHA12",masterstring,0x803D);
			etb_->registerEnum("GL_ALPHA16",masterstring,0x803E);
			etb_->registerEnum("GL_LUMINANCE4",masterstring,0x803F);
			etb_->registerEnum("GL_LUMINANCE8",masterstring,0x8040);
			etb_->registerEnum("GL_LUMINANCE12",masterstring,0x8041);
			etb_->registerEnum("GL_LUMINANCE16",masterstring,0x8042);
			etb_->registerEnum("GL_LUMINANCE4_ALPHA4",masterstring,0x8043);
			etb_->registerEnum("GL_LUMINANCE6_ALPHA2",masterstring,0x8044);
			etb_->registerEnum("GL_LUMINANCE8_ALPHA8",masterstring,0x8045);
			etb_->registerEnum("GL_LUMINANCE12_ALPHA4",masterstring,0x8046);
			etb_->registerEnum("GL_LUMINANCE12_ALPHA12",masterstring,0x8047);
			etb_->registerEnum("GL_LUMINANCE16_ALPHA16",masterstring,0x8048);
			etb_->registerEnum("GL_INTENSITY",masterstring,0x8049);
			etb_->registerEnum("GL_INTENSITY4",masterstring,0x804A);
			etb_->registerEnum("GL_INTENSITY8",masterstring,0x804B);
			etb_->registerEnum("GL_INTENSITY12",masterstring,0x804C);
			etb_->registerEnum("GL_INTENSITY16",masterstring,0x804D);
			etb_->registerEnum("GL_R3_G3_B2",masterstring,0x2A10);
			etb_->registerEnum("GL_RGB4",masterstring,0x804F);
			etb_->registerEnum("GL_RGB5",masterstring,0x8050);
			etb_->registerEnum("GL_RGB8",masterstring,0x8051);
			etb_->registerEnum("GL_RGB10",masterstring,0x8052);
			etb_->registerEnum("GL_RGB12",masterstring,0x8053);
			etb_->registerEnum("GL_RGB16",masterstring,0x8054);
			etb_->registerEnum("GL_RGBA2",masterstring,0x8055);
			etb_->registerEnum("GL_RGBA4",masterstring,0x8056);
			etb_->registerEnum("GL_RGB5_A1",masterstring,0x8057);
			etb_->registerEnum("GL_RGBA8",masterstring,0x8058);
			etb_->registerEnum("GL_RGB10_A2",masterstring,0x8059);
			etb_->registerEnum("GL_RGBA12",masterstring,0x805A);
			etb_->registerEnum("GL_RGBA16",masterstring,0x805B);
			etb_->registerEnum("GL_TEXTURE_RED_SIZE",masterstring,0x805C);
			etb_->registerEnum("GL_TEXTURE_GREEN_SIZE",masterstring,0x805D);
			etb_->registerEnum("GL_TEXTURE_BLUE_SIZE",masterstring,0x805E);
			etb_->registerEnum("GL_TEXTURE_ALPHA_SIZE",masterstring,0x805F);
			etb_->registerEnum("GL_TEXTURE_LUMINANCE_SIZE",masterstring,0x8060);
			etb_->registerEnum("GL_TEXTURE_INTENSITY_SIZE",masterstring,0x8061);
			etb_->registerEnum("GL_PROXY_TEXTURE_1D",masterstring,0x8063);
			etb_->registerEnum("GL_PROXY_TEXTURE_2D",masterstring,0x8064);

			/* EXT_bgra */
			etb_->registerEnum("GL_BGR_EXT",masterstring,0x80E0);
			etb_->registerEnum("GL_BGRA_EXT",masterstring,0x80E1);

			/* EXT_paletted_texture */
			etb_->registerEnum("GL_COLOR_INDEX1_EXT",masterstring,0x80E2);
			etb_->registerEnum("GL_COLOR_INDEX2_EXT",masterstring,0x80E3);
			etb_->registerEnum("GL_COLOR_INDEX4_EXT",masterstring,0x80E4);
			etb_->registerEnum("GL_COLOR_INDEX8_EXT",masterstring,0x80E5);
			etb_->registerEnum("GL_COLOR_INDEX12_EXT",masterstring,0x80E6);
			etb_->registerEnum("GL_COLOR_INDEX16_EXT",masterstring,0x80E7);
		}
		return etb_;
	}

};

struct InitOpenGLWrapper {
	InitOpenGLWrapper() {
		WrapperManager::registerPrototype(new OpengGLWrapper());
	}
};
static InitOpenGLWrapper instanceOfImageWrapper ;



const char* type2strGL(const int& t) {
	return (char*)OpengGLWrapper::Enumtable()->enumName(t);
}

const char* type2strGL(const unsigned int& t) {
	return (char*)OpengGLWrapper::Enumtable()->enumName(t);
}

int str2typeGL(const char* in, int*) {
	return OpengGLWrapper::Enumtable()->enumValue(in);
}

unsigned int str2typeGL(const char* in, unsigned int*) {
	return (unsigned int)OpengGLWrapper::Enumtable()->enumValue(in);
}

IVRS_NAMESPACE_END

