#include <ivrs/stringconvert.h>
#include <ivrs/vectorwrp.h>
#include <ivrs/gen/vertexdatawrp.h>
#include <ivrs/methodtable.h>
#include <ivrs/wrappermanager.h>

IVRS_NAMESPACE_BEGIN
using namespace VRS;
using namespace LDX;

WrapperClassInfo* Wrp_Vector::WrapperInfo() {
	static WrapperClassInfo i( typeid(Vector) , Wrp_VertexData<3,double>::WrapperInfo());
	return &i;
}

//  Vector ( double double double )
const char* Wrp_Vector::m_5649_45290(int argc, const char** argv) {
	double arg0 = (argc <= 0) ? 0.0 : str2type(argv[0],(double*)0);
	double arg1 = (argc <= 1) ? 0.0 : str2type(argv[1],(double*)0);
	double arg2 = (argc <= 2) ? 0.0 : str2type(argv[2],(double*)0);
	obj_ = new Vector(arg0,arg1,arg2);
	return 0;
}

// bool operator== ( Vector )
const char* Wrp_Vector::m_27814_5649(int argc, const char** argv) {
	Vector arg0 = str2type(argv[0],(Vector*)0);
	const bool value = reinterpret_cast<Vector*>(obj_)->operator==(arg0);
	return type2str(value);
}

// bool operator!= ( Vector )
const char* Wrp_Vector::m_27282_5649(int argc, const char** argv) {
	Vector arg0 = str2type(argv[0],(Vector*)0);
	const bool value = reinterpret_cast<Vector*>(obj_)->operator!=(arg0);
	return type2str(value);
}

// bool operator< ( Vector )
const char* Wrp_Vector::m_25093_5649(int argc, const char** argv) {
	Vector arg0 = str2type(argv[0],(Vector*)0);
	const bool value = reinterpret_cast<Vector*>(obj_)->operator<(arg0);
	return type2str(value);
}

// Vector& operator+= ( Vector )
const char* Wrp_Vector::m_12176_5649(int argc, const char** argv) {
	Vector arg0 = str2type(argv[0],(Vector*)0);
	const Vector& value = reinterpret_cast<Vector*>(obj_)->operator+=(arg0);
	return type2str(value);
}

// Vector& operator-= ( Vector )
const char* Wrp_Vector::m_12214_5649(int argc, const char** argv) {
	Vector arg0 = str2type(argv[0],(Vector*)0);
	const Vector& value = reinterpret_cast<Vector*>(obj_)->operator-=(arg0);
	return type2str(value);
}

// Vector& operator*= ( Vector )
const char* Wrp_Vector::m_12157_5649(int argc, const char** argv) {
	Vector arg0 = str2type(argv[0],(Vector*)0);
	const Vector& value = reinterpret_cast<Vector*>(obj_)->operator*=(arg0);
	return type2str(value);
}

// Vector& operator*= ( double )
const char* Wrp_Vector::m_12157_5741(int argc, const char** argv) {
	double arg0 = str2type(argv[0],(double*)0);
	const Vector& value = reinterpret_cast<Vector*>(obj_)->operator*=(arg0);
	return type2str(value);
}

// Vector& operator/= ( double )
const char* Wrp_Vector::m_12252_5741(int argc, const char** argv) {
	double arg0 = str2type(argv[0],(double*)0);
	const Vector& value = reinterpret_cast<Vector*>(obj_)->operator/=(arg0);
	return type2str(value);
}

// Vector operator+ ( Vector )
const char* Wrp_Vector::m_24736_5649(int argc, const char** argv) {
	Vector arg0 = str2type(argv[0],(Vector*)0);
	const Vector value = reinterpret_cast<Vector*>(obj_)->operator+(arg0);
	return type2str(value);
}

// Vector operator- ( Vector )
const char* Wrp_Vector::m_24778_5649(int argc, const char** argv) {
	Vector arg0 = str2type(argv[0],(Vector*)0);
	const Vector value = reinterpret_cast<Vector*>(obj_)->operator-(arg0);
	return type2str(value);
}

// Vector operator* ( Vector )
const char* Wrp_Vector::m_24715_5649(int argc, const char** argv) {
	Vector arg0 = str2type(argv[0],(Vector*)0);
	const Vector value = reinterpret_cast<Vector*>(obj_)->operator*(arg0);
	return type2str(value);
}

// Vector operator* ( double )
const char* Wrp_Vector::m_24715_5741(int argc, const char** argv) {
	double arg0 = str2type(argv[0],(double*)0);
	const Vector value = reinterpret_cast<Vector*>(obj_)->operator*(arg0);
	return type2str(value);
}

// Vector operator/ ( double )
const char* Wrp_Vector::m_24820_5741(int argc, const char** argv) {
	double arg0 = str2type(argv[0],(double*)0);
	const Vector value = reinterpret_cast<Vector*>(obj_)->operator/(arg0);
	return type2str(value);
}

// Vector operator- (  )
const char* Wrp_Vector::m_24778_0(int argc, const char** argv) {
	const Vector value = reinterpret_cast<Vector*>(obj_)->operator-();
	return type2str(value);
}

// Vector normalized (  )
const char* Wrp_Vector::m_29344_0(int argc, const char** argv) {
	const Vector value = reinterpret_cast<Vector*>(obj_)->normalized();
	return type2str(value);
}

// bool normalize (  )
const char* Wrp_Vector::m_11702_0(int argc, const char** argv) {
	const bool value = reinterpret_cast<Vector*>(obj_)->normalize();
	return type2str(value);
}

// double abs (  )
const char* Wrp_Vector::m_9616_0(int argc, const char** argv) {
	const double value = reinterpret_cast<Vector*>(obj_)->abs();
	return type2str(value);
}

// double abs2 (  )
const char* Wrp_Vector::m_11110_0(int argc, const char** argv) {
	const double value = reinterpret_cast<Vector*>(obj_)->abs2();
	return type2str(value);
}

// double dotProduct ( Vector )
const char* Wrp_Vector::m_29264_5649(int argc, const char** argv) {
	Vector arg0 = str2type(argv[0],(Vector*)0);
	const double value = reinterpret_cast<Vector*>(obj_)->dotProduct(arg0);
	return type2str(value);
}

// Vector crossProduct ( Vector )
const char* Wrp_Vector::m_36977_5649(int argc, const char** argv) {
	Vector arg0 = str2type(argv[0],(Vector*)0);
	const Vector value = reinterpret_cast<Vector*>(obj_)->crossProduct(arg0);
	return type2str(value);
}

// bool isOrigin (  )
const char* Wrp_Vector::m_22368_0(int argc, const char** argv) {
	const bool value = reinterpret_cast<Vector*>(obj_)->isOrigin();
	return type2str(value);
}

MethodTable* Wrp_Vector::methodTable() const {
	static MethodTable* dta_ = 0;
	if (!dta_) {
		dta_ = new MethodTable(Wrp_VertexData<3,double>::methodTable());
		dta_->insert("Ctor",(Wrapper::FKT)&Wrp_Vector::m_5649_45290,"","double double double","x y z","0.0 0.0 0.0",0,3,MethodTable::CTOR);
		dta_->insert("==",(Wrapper::FKT)&Wrp_Vector::m_27814_5649,"bool","Vector","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("!=",(Wrapper::FKT)&Wrp_Vector::m_27282_5649,"bool","Vector","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("<",(Wrapper::FKT)&Wrp_Vector::m_25093_5649,"bool","Vector","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("+=",(Wrapper::FKT)&Wrp_Vector::m_12176_5649,"Vector&","Vector","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("-=",(Wrapper::FKT)&Wrp_Vector::m_12214_5649,"Vector&","Vector","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("*=",(Wrapper::FKT)&Wrp_Vector::m_12157_5649,"Vector&","Vector","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("*=",(Wrapper::FKT)&Wrp_Vector::m_12157_5741,"Vector&","double","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("/=",(Wrapper::FKT)&Wrp_Vector::m_12252_5741,"Vector&","double","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("+",(Wrapper::FKT)&Wrp_Vector::m_24736_5649,"Vector","Vector","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("-",(Wrapper::FKT)&Wrp_Vector::m_24778_5649,"Vector","Vector","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("*",(Wrapper::FKT)&Wrp_Vector::m_24715_5649,"Vector","Vector","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("*",(Wrapper::FKT)&Wrp_Vector::m_24715_5741,"Vector","double","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("/",(Wrapper::FKT)&Wrp_Vector::m_24820_5741,"Vector","double","noname","{}",1,1,MethodTable::METHOD);
		dta_->insert("-",(Wrapper::FKT)&Wrp_Vector::m_24778_0,"Vector","","","",0,0,MethodTable::METHOD);
		dta_->insert("normalized",(Wrapper::FKT)&Wrp_Vector::m_29344_0,"Vector","","","",0,0,MethodTable::METHOD);
		dta_->insert("normalize",(Wrapper::FKT)&Wrp_Vector::m_11702_0,"bool","","","",0,0,MethodTable::METHOD);
		dta_->insert("abs",(Wrapper::FKT)&Wrp_Vector::m_9616_0,"double","","","",0,0,MethodTable::METHOD);
		dta_->insert("abs2",(Wrapper::FKT)&Wrp_Vector::m_11110_0,"double","","","",0,0,MethodTable::METHOD);
		dta_->insert("dotProduct",(Wrapper::FKT)&Wrp_Vector::m_29264_5649,"double","Vector","other","{}",1,1,MethodTable::METHOD);
		dta_->insert("crossProduct",(Wrapper::FKT)&Wrp_Vector::m_36977_5649,"Vector","Vector","other","{}",1,1,MethodTable::METHOD);
		dta_->insert("isOrigin",(Wrapper::FKT)&Wrp_Vector::m_22368_0,"bool","","","",0,0,MethodTable::METHOD);

	}
	return dta_;
}
static PrototypeRegister instanceOfWrp_Vector(new Wrp_Vector(0));

IVRS_NAMESPACE_END

