#include <ivrs/wrapperexception.h>
#include <strstream>

IVRS_NAMESPACE_BEGIN



const char* WrapperException::message() const {
    return msg_;
}


InternalException::InternalException(const char* reason, const char* scope,  const char** argv) {
    std::strstream buf;
    buf << "Error in '" << scope << "' wrapper:\n" << reason << std::endl;
    if (argv) {
        buf << "arguments: " ;   
        while (*argv) { buf << (*(argv++)) << " "; }
    }
    buf << std::ends;    
    msg_ = buf.str();
}

InternalException::~InternalException() {
  //  delete[] msg_;
}

ConvertException::ConvertException (const char* destination, const char* input) {
    static char buf[1024];
    sprintf(buf,"Could not convert '%s' to '%s'",input,destination);
    msg_ = buf;
}

ConvertException::~ConvertException() {
   // delete[] msg_;
}

IVRS_NAMESPACE_END