# load VRS package if isn't loaded
source initvrs.tcl
 
# view
set lookat [new LookAt {1 1 -2} {0 0 0}]
set perspective [new Perspective 60  0.1  100]
set view [new SceneView  $perspective  $lookat]

# main scene graph
set mainThing_ [new SceneThing $view]
$mainThing_ append [new PointLight { -1 1 -1 } {1 1 1 1} 1 0.6 1  ]
$mainThing_ append [new DistantLight { 1 1 1 }   ]
$mainThing_ append   [new ColorAttribute  {0 0 0 1}]
$mainThing_ append   [set facestyle [new FaceStyle FaceStyle::Filled FaceStyle::Culled]]

set shape [ObjectLoader readFile pics/dinopet.3ds]
$mainThing_ append $shape
    
# make 3D canvas
toplevel .opengl
set canvas [new TclCanvas .opengl.canvas 400  400  ]
    
# add geometry graphs and behavior graphs
$canvas append $view  
$canvas append [new ResizeHandler  $view]
$canvas append [new TrackBall  $mainThing_]        
$canvas append [new LookAtManipulator  $lookat LookAtManipulator::Zoom InputEvent::MouseButton3]


proc load3DSShape {} {
	global shape mainThing_

	set filename [tk_getOpenFile]
	if {$filename == ""} { return }
	if {$shape != ""} {	$mainThing_ remove $shape }

	cd [file dirname $filename]
	set shape [ObjectLoader readFile $filename]

	$mainThing_ append $shape
}

#
# MENUS
#
frame .opengl.mbar -border 1 -relief raised
menubutton .opengl.mbar.file -text File -menu .opengl.mbar.file.m

menu .opengl.mbar.file.m
.opengl.mbar.file.m add command -label "Load" -command load3DSShape
.opengl.mbar.file.m add command -label "Quit" -command "destroy .opengl; VRS cleanup"

pack .opengl.mbar.file -side left
pack .opengl.mbar -fill x

#
# CANVAS
#
pack .opengl.canvas -fill both -expand yes




