# load package if isn't loaded
package require VRS
 
# object to be displayed
set shape_ [new Composite]
$shape_ append  [new Sphere  0.3 {0 1 0}]
$shape_ append  [new Sphere  0.3 {0 0 -1}]
$shape_ append  [new Sphere  0.3 {-1 0 0}]
$shape_ append  [new Sphere  0.3 {1 0 0}]
$shape_ append  [new Cylinder   {0 1 0}  {0 0 -1}   0.1]
$shape_ append  [new Cylinder   {0 1 0}  {-1 0 0}  0.1] 
$shape_ append  [new Cylinder   {0 1 0}  {1 0 0}  0.1]   
$shape_ append  [new Cylinder   {-1 0 0} {1 0 0}   0.1]   
$shape_ append  [new Cylinder   {-1 0 0} {0 0 -1}   0.1]   
$shape_ append  [new Cylinder   {1 0 0}  {0 0 -1}   0.1]   
    
# view
set view [new SceneThing]
set lookat [new LookAt {1 1 -2} {0 0 0}]
set perspective [new Perspective 60  0.1  100]
$view append [new Camera $perspective $lookat]

# main scene graph
set mainThing_ [new SceneThing $view]
$mainThing_ append [new DistantLight { 1 1 1 }   ]
$mainThing_ append [new PointLight { 0 1 -2 } ]  
$mainThing_ append   [new ColorAttribute  {0 0 0 1}]
$mainThing_ append   [new FaceStyle  FaceStyle::Outlined FaceStyle::Outlined]
$mainThing_ append   [new Cache  $shape_]
$mainThing_ append   [new FaceStyle  FaceStyle::Filled  FaceStyle::Filled]
$mainThing_ append   [new Material  0.6  1.0  0.3]
$mainThing_ append   [new ColorAttribute  {1 0 0 1}]  
$mainThing_ append   [new Cache  $shape_]
    
# create PolygonOffset
set polyOffset [new PolygonOffsetGL PolygonOffsetGL::Fill]

# make 3D canvas

set canvas [new TclCanvas .canvas 400  400  ]
    

set config [new SceneConfiguration]
$config append [new BackgroundGL {0.2 0.2 0.2 1.0} {0.9 0.9 0.9 1.0} BackgroundGL::TopToBottom]

# add geometry graphs and behavior graphs
$canvas  append $config
$canvas  append $view  
$canvas append [new TrackBall  $mainThing_]        
$canvas append [new LookAtManipulator  $lookat LookAtManipulator::Zoom InputEvent::MouseButton2]


#
# MENUS
#
frame .mbar -border 1 -relief raised
menubutton .mbar.file -text File -menu .mbar.file.m
menubutton .mbar.options -text Options -menu .mbar.options.m
menubutton .mbar.help -text Help -menu .mbar.help.m

menu .mbar.file.m
.mbar.file.m add command -label "Quit" -command "destroy . ; VRS cleanup"

menu .mbar.options.m 
.mbar.options.m add check -label "Polygon offset" \
	-variable offset -command { 
		if {$offset} {
			$mainThing_ prepend $polyOffset               
	    } else {        
            if {[$mainThing_ contains $polyOffset]} { $mainThing_ remove $polyOffset }  
        }
	}


pack .mbar.file -side left
pack .mbar.options -side left
pack .mbar -fill x

#
# CANVAS
#
pack  .canvas -fill both -expand yes




