# load package if isn't loaded
package require VRS




# MENUS
frame .mbar -border 1 -relief raised
menubutton .mbar.file -text File -menu .mbar.file.m

menu .mbar.file.m
.mbar.file.m add command -label "Quit" -command "destroy .; VRS cleanup"
pack .mbar.file -side left
pack .mbar -fill x

#
# CANVAS
#
set canvas [new TclCanvas .toto 320 240]
.toto configure -width 512 -height 512
pack .toto -fill both -expand yes


# create the pbuffer canvas
set pbuffer_ [new PBufferCanvasGL 512 512 GLCanvas::RGBADS $canvas]

# the pbuffer-texture contains the contents of the pbuffer frame buffer
set texture_ [$pbuffer_ getContentTexture]

set shape_ [new Cache [new Box {-0.7 -0.7 -0.7} {0.7 0.7 0.7}]]

# create view for main canvas
set mainview [new SceneThing]
$mainview append [new Camera {0 0 -2} {0 0 0} 60]

# create the scene objects
set scene_ [new SceneThing $mainview]
$scene_ append [new TexEnvGL TexEnvGL::Decal]
$scene_ append $texture_
$scene_ append $shape_


# connect geometry graphs and behavior graphs to canvas
$canvas append $mainview
$canvas append [new TrackBall $scene_]


set config [new SceneConfiguration]
$config append [new BackgroundGL {0.2 0.2 0.2 1.0} {0.9 0.9 0.9 1.0} BackgroundGL::TopToBottom]

$pbuffer_ append $config
$pbuffer_ append $mainview



# check for pbuffer
if {$tcl_platform(platform) == "windows"} {
    update
    if {![regexp WGL_ARB_pbuffer [$canvas glInfo]]} {
	    tk_messageBox -message "Sorry, need WGL_ARB_pbuffer extension to run." -icon error
	    destroy .
	    VRS cleanup
    }
} 
