#

source ../tkcon.tcl
load ../../lib/ivrs_debug.dll vrs

#
# Mechanism to cleanup iVRS objects
#
# % setnew sphere [new Sphere]   # Sphere object created
# % set sphere [new Sphere]      # old Sphere object deleted and new Sphere generated
# % unset sphere                 # new Sphere object deleted and variable unset
#


proc _iVRScleanup {varname index op} {	
	global TempVRSObj
	set obj $TempVRSObj($varname)
	delete $obj
	if {$op == "u"} {
		unset $TempVRSObj($varname)
		trace vdelete $varname wu _iVRScleanup
	}		
}

proc setnew { varname obj} {
	global TempVRSObj	
	upvar 1 $varname var
	set TempVRSObj($varname) $obj
	set var $obj
	trace variable $varname wu _iVRScleanup
	return $obj
}

