# console show

set excludeFiles {
# exclude files from include/vrs
assert|exception|config\.h|
observelifetime|functioncallback\.h|methodcallback\.h|
vrs\.h|package|vrs_glut\.h|simplifier|
progress\.h|progressbar\.h|
intersector|painter|errorhandler|
transactionno|so\.h|string|typeinfo|
hierarchyprinter|memoryutil|
colorscale|bspline|volume|nurbs|vertexattribute|
analyticshapegenerators|polygonsetbuilder|

# exclude files from include/vrs/io 
/io\.h|ioerror\.h|file\.h|reader|imageloader|unixfilter|

# exclude files from include/vrs/opengl
glext\.h|opengl\.h|openglconfig|stereogl|pbuffermanagergl|
enginegl\.h|

# exclude files from inlcude/sg 
key\.h|functiontimemap|keycondition|fpsclock|moment\.h|time|

# exclude files from include/vrs/opengl
imagepixelfilter|maplens
}

set excludeClasses {DocFormatError|DocStreamError|GeometryGlyph|^Glyph|ImageGlyph|
ImageRecord|PassesSetup|DepthmapShadowTechniqueGL|AlphaTextureShadowTechniqueGL|
DepthTextureShadowTechniqueGL|EdgeIterator|VisitorBase}


set excludeMethods {~|ref$|rep$|accept|acceptChildren|
getUnicodeText|setUnicodeText|slice|serialize|
getAdjacentFaces|getEdgesOfType|getEdges|
getMaxTexCoords|getMinTexCoords|
parameters|readNames|setPrimitiveIterator|newPrimitiveIterator|STL|\[}

set excludeArgs {stream|\.\.\.|ClassInfo|Document|
Array|GLString|ObjectReader|ImageDitherOp|Constructor|
TimeRequirement|Time|VRSTime|Moment|TimeSlave|TransactionNo|
DocStreamError|std::vector|int&|bool&|Matrix&|ColorMapper|VertexData}

set parseDirs {
../../vrs/include/vrs/opengl/*.h
../../vrs/include/vrs/image/*.h
../../vrs/include/vrs/io/*.h
../../vrs/include/vrs/sg/*.h
../../vrs/include/vrs/container/*.h
../../vrs/include/vrs/*.h
}


set parseAdditionalFiles { 
../../vrs/include/vrs/tcl/tclcanvas.h
../../vrs/include/vrs/tcl/tclcallback.h
../../vrs/include/vrs/shapepainter.h
../../vrs/include/vrs/painter.h
../../vrs/include/vrs/io/objectreader.h
../../vrs/include/vrs/io/threedsreader.h
../../vrs/include/vrs/sg/timeevent.h
../include/ivrs/tcl/tcltemplatecallback.h
}



########################################################################################


# source parser and data support
set OptimizeParser 0
set OptimizeGenerator 0
set errorlog 1

# create necessary directories
foreach d {../include/ivrs/gen ../src/gen  logs} {
	if {![file exists $d]} { file mkdir $d }
}

# data structure
source data.tcl

# intitialize database
db::initialize 
if {$OptimizeParser && [db::readData]} { puts stderr "using cached data" }

# parse
puts "+++++ analyzing classes..."
source parser.tcl
puts "+++++ ok"

# save database
db::writeData


# write output
puts "+++++ writing output ..."
source writeresult.tcl
puts "+++++ ok"


# generate 
puts "+++++ generating code ..."
source generator.tcl
puts "+++++ ok"


db::printStatics
