console show

set excludeFiles {
# exclude files from include/vrs
assert|exception|config\.h|
observelifetime|functioncallback\.h|methodcallback\.h|
vrs\.h|package|vrs_glut\.h|simplifier|
intersector|painter|errorhandler|
transactionno|so\.h|string|typeinfo|
colorscale|bspline|volume|nurbs|vertexattribute|

# exclude files from include/vrs/io 
/io\.h|ioerror\.h|file\.h|reader|imageloader|unixfilter|

# exclude files from include/vrs/opengl
glext\.h|opengl\.h|openglconfig|stereogl|cubeenvmirror|

# exclude files from inlcude/sg 
key\.h|functiontimemap|keycondition|fpsclock|moment\.h|time|

# exclude files from include/vrs/image
imagepixelfilter
}

set excludeClasses {DocFormatError|DocStreamError|GeometryGlyph|^Glyph|ImageGlyph|
ImageRecord|MapTerrainSurface|Mutex|PassesSetup|Semaphore|ResourceManager|Thread|
CompressedLODTexture|DistanceTextureSwitch|HypsometryTexture|MapDistanceSwitchTexture|
SequenceTexture|StencilTexture|TerrainTexturePatchManager|ColorMapper|
DepthmapShadowTechniqueGL|AlphaTextureShadowTechniqueGL|DepthTextureShadowTechniqueGL}

set excludeMethods {~|ref$|rep$|getAction|setAction|
getUnicodeText|setUnicodeText|slice|serialize|
parameters|readNames|setPrimitiveIterator|
newPrimitiveIterator|STL|\[}

set excludeArgs {stream|\.\.\.|ClassInfo|Document|
Action|Array|GLString|ObjectReader|ImageDitherOp|Constructor|
TimeRequirement|Time|VRSTime|Moment|TimeSlave|TransactionNo|
DocStreamError|std::vector|int&|bool&|Matrix&|ColorMapper|VertexData}


set parseDirs {
../../vrs/include/vrs/opengl/*.h
../../vrs/include/vrs/image/*.h
../../vrs/include/vrs/io/*.h
../../vrs/include/vrs/sg/*.h
../../vrs/include/vrs/container/*.h
../../vrs/include/vrs/*.h
../../ldx/include/ldx/io/*.h
../../ldx/include/ldx/misc/*.h
../../ldx/include/ldx/map/visual/*.h
../../ldx/include/ldx/map/structural/*.h
../../ldx/include/ldx/map/behavioral/*.h
../../ldx/include/ldx/terrain/geometry/*.h
../../ldx/include/ldx/terrain/texture/*.h
../../ldx/include/ldx/raster/*.h
}

set parseAdditionalFiles { 
../../vrs/include/vrs/tcl/tclcanvas.h
../../vrs/include/vrs/tcl/tclcallback.h
../../vrs/include/vrs/shapepainter.h
../../vrs/include/vrs/painter.h
../../vrs/include/vrs/io/objectreader.h
../../vrs/include/vrs/io/threedsreader.h
../../vrs/include/vrs/sg/timeevent.h
../../ldx/include/ldx/terrain/geometry/terrainpaintergl.h
../include/ivrs/tcl/tcltemplatecallback.h
}

########################################################################################


# source parser and data support
set OptimizeParser 1
set OptimizeGenerator 1
set errorlog 0

# create necessary directories
foreach d {../include/ivrs/gen ../src/gen  logs} {
	if {![file exists $d]} { file mkdir $d }
}

# data structure
source data.tcl

# intitialize database
db::initialize 
if {$OptimizeParser && [db::readData]} { puts stderr "using cached data" }

# parse
puts "+++++ analyzing classes..."
source parser.tcl
puts "+++++ ok"

# save database
db::writeData

# write output
puts "+++++ writing output ..."
source writeresult.tcl
puts "+++++ ok"

# generate 
puts "+++++ generating code ..."
source generator.tcl
puts "+++++ ok"

#db::printStatics